Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4140)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4141)
@@ -3715,101 +3558,430 @@
 ! Description:
 ! ------------
-!> Finalize output.
-!--------------------------------------------------------------------------------------------------!
-FUNCTION dom_finalize_output() RESULT( return_value )
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_finalize_output'  !< name of routine
-
-   INTEGER(iwp) ::  return_value           !< return value
-   INTEGER(iwp) ::  return_value_internal  !< error code after closing a single file
-   INTEGER(iwp) ::  output_return_value    !< return value from called routines
-   INTEGER(iwp) ::  f                      !< loop index
-
-
-   return_value = 0
-
-   DO  f = 1, nf
-
-      IF ( files(f)%is_init )  THEN
-
-         output_return_value = 0
-         return_value_internal = 0
-
-         SELECT CASE ( TRIM( files(f)%format ) )
-
-            CASE ( 'binary' )
-               CALL binary_finalize( files(f)%id, output_return_value )
-
-            CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
-               CALL netcdf4_finalize( files(f)%id, output_return_value )
-
-            CASE DEFAULT
-               return_value_internal = 1
-
-         END SELECT
-
-         IF ( output_return_value /= 0 )  THEN
-            return_value = output_return_value
-            CALL internal_message( 'error', routine_name //             &
-                                   ': error while finalizing file "' // &
-                                   TRIM( files(f)%name ) // '"' )
-         ELSEIF ( return_value_internal /= 0 )  THEN
-            return_value = return_value_internal
-            CALL internal_message( 'error', routine_name //         &
-                                   ': unsupported file format "' // &
-                                   TRIM( files(f)%format ) // '"' )
-         ENDIF
-
-      ENDIF
-
-   ENDDO
-
-END FUNCTION dom_finalize_output
+!> Message routine writing debug information into the debug file
+!> or creating the error message string.
+!--------------------------------------------------------------------------------------------------!
+SUBROUTINE internal_message( level, string )
+
+   CHARACTER(LEN=*), INTENT(IN) ::  level   !< message importance level
+   CHARACTER(LEN=*), INTENT(IN) ::  string  !< message string
+
+
+   IF ( TRIM( level ) == 'error' )  THEN
+
+      WRITE( internal_error_message, '(A,A)' ) 'DOM ERROR: ', string
+
+   ELSEIF ( TRIM( level ) == 'debug'  .AND.  print_debug_output )  THEN
+
+      WRITE( debug_output_unit, '(A,A)' ) 'DOM DEBUG: ', string
+      FLUSH( debug_output_unit )
+
+   ENDIF
+
+END SUBROUTINE internal_message
 
 !--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Message routine writing debug information into the debug file
-!> or creating the error message string.
-!--------------------------------------------------------------------------------------------------!
-SUBROUTINE internal_message( level, string )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  level   !< message importance level
-   CHARACTER(LEN=*), INTENT(IN) ::  string  !< message string
-
-
-   IF ( TRIM( level ) == 'error' )  THEN
-
-      WRITE( internal_error_message, '(A,A)' ) 'DOM ERROR: ', string
-
-   ELSEIF ( TRIM( level ) == 'debug'  .AND.  print_debug_output )  THEN
-
-      WRITE( debug_output_unit, '(A,A)' ) 'DOM DEBUG: ', string
-      FLUSH( debug_output_unit )
+!> Print contents of the created database to debug_output_unit. This routine can be called at any
+!> stage after the call to 'dom_init'. Multiple calls are possible.
+!--------------------------------------------------------------------------------------------------!
+SUBROUTINE dom_database_debug_output
+
+   CHARACTER(LEN=*), PARAMETER ::  separation_string = '---'                   !< string separating blocks in output
+   CHARACTER(LEN=50)           ::  write_format1                               !< format for write statements
+   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_database_debug_output'  !< name of this routine
+
+   INTEGER            ::  f                       !< loop index
+   INTEGER, PARAMETER ::  indent_depth = 3        !< space per indentation
+   INTEGER            ::  indent_level            !< indentation level
+   INTEGER, PARAMETER ::  max_keyname_length = 6  !< length of longest key name
+   INTEGER            ::  natts                   !< number of attributes
+   INTEGER            ::  ndims                   !< number of dimensions
+   INTEGER            ::  nvars                   !< number of variables
+
+
+   CALL internal_message( 'debug', routine_name // ': write database to debug output' )
+
+   WRITE( debug_output_unit, '(A)' ) 'DOM database:'
+   WRITE( debug_output_unit, '(A)' ) REPEAT( separation_string // ' ', 4 )
+
+   IF ( .NOT. ALLOCATED( files ) .OR. nfiles == 0 )  THEN
+
+      WRITE( debug_output_unit, '(A)' ) 'database is empty'
+
+   ELSE
+
+      indent_level = 1
+      WRITE( write_format1, '(A,I3,A,I3,A)' ) '(T', indent_level * indent_depth + 1, ',A,T',  &
+                                        indent_level * indent_depth + 1 + max_keyname_length, &
+                                        ',(": ")'
+
+      DO  f = 1, nfiles
+
+         natts = 0
+         ndims = 0
+         nvars = 0
+         IF ( ALLOCATED( files(f)%attributes ) ) natts = SIZE( files(f)%attributes )
+         IF ( ALLOCATED( files(f)%dimensions ) ) ndims = SIZE( files(f)%dimensions )
+         IF ( ALLOCATED( files(f)%variables  ) ) nvars = SIZE( files(f)%variables  )
+
+         WRITE( debug_output_unit, '(A)' ) 'file:'
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',A)' ) 'name', TRIM( files(f)%name )
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',A)' ) 'format', TRIM(files(f)%format)
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',I7)' ) 'id', files(f)%id
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',L1)' ) 'is init', files(f)%is_init
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',I7)' ) '#atts', natts
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',I7)' ) '#dims', ndims
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',I7)' ) '#vars', nvars
+
+         IF ( natts /= 0 )  CALL print_attributes( indent_level, files(f)%attributes )
+         IF ( ndims /= 0 )  CALL print_dimensions( indent_level, files(f)%dimensions )
+         IF ( nvars /= 0 )  CALL print_variables( indent_level, files(f)%variables )
+
+         WRITE( debug_output_unit, '(/A/)' ) REPEAT( separation_string // ' ', 4 )
+
+      ENDDO
 
    ENDIF
 
-END SUBROUTINE internal_message
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Return the last created error message.
-!--------------------------------------------------------------------------------------------------!
-SUBROUTINE dom_get_error_message( error_message )
-
-   CHARACTER(LEN=800), INTENT(OUT) ::  error_message         !< return error message to main program
-   CHARACTER(LEN=800)              ::  output_error_message  !< error message created by other module
-
-
-   CALL binary_get_error_message( output_error_message )
-   internal_error_message = TRIM( internal_error_message ) // output_error_message
-
-   CALL netcdf4_get_error_message( output_error_message )
-   internal_error_message = TRIM( internal_error_message ) // output_error_message
-
-   error_message = internal_error_message
-
-END SUBROUTINE dom_get_error_message
+   CONTAINS
+
+      !--------------------------------------------------------------------------------------------!
+      ! Description:
+      ! ------------
+      !> Print list of attributes.
+      !--------------------------------------------------------------------------------------------!
+      SUBROUTINE print_attributes( indent_level, attributes )
+
+         CHARACTER(LEN=50) ::  write_format1  !< format for write statements
+         CHARACTER(LEN=50) ::  write_format2  !< format for write statements
+
+         INTEGER             ::  i                       !< loop index
+         INTEGER, INTENT(IN) ::  indent_level            !< indentation level
+         INTEGER, PARAMETER  ::  max_keyname_length = 6  !< length of longest key name
+         INTEGER             ::  nelement                !< number of elements to print
+
+         TYPE(attribute_type), DIMENSION(:), INTENT(IN) ::  attributes  !< list of attributes
+
+
+         WRITE( write_format1, '(A,I3,A)' ) '(T', indent_level * indent_depth + 1, ',A'
+         WRITE( write_format2, '(A,I3,A,I3,A)' ) &
+            '(T', ( indent_level + 1 ) * indent_depth + 1, ',A,T', &
+            ( indent_level + 1 ) * indent_depth + 1 + max_keyname_length, ',(": ")'
+
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',A)' ) &
+            REPEAT( separation_string // ' ', 4 )
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ')' ) 'attributes:'
+
+         nelement = SIZE( attributes )
+         DO  i = 1, nelement
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',A)' ) &
+               'name', TRIM( attributes(i)%name )
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',A)' ) &
+               'type', TRIM( attributes(i)%data_type )
+
+            IF ( TRIM( attributes(i)%data_type ) == 'char' )  THEN
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',A)' ) &
+                  'value', TRIM( attributes(i)%value_char )
+            ELSEIF ( TRIM( attributes(i)%data_type ) == 'int8' )  THEN
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',I4)' ) &
+                  'value', attributes(i)%value_int8
+            ELSEIF ( TRIM( attributes(i)%data_type ) == 'int16' )  THEN
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',I6)' ) &
+                  'value', attributes(i)%value_int16
+            ELSEIF ( TRIM( attributes(i)%data_type ) == 'int32' )  THEN
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',I11)' ) &
+                  'value', attributes(i)%value_int32
+            ELSEIF ( TRIM( attributes(i)%data_type ) == 'real32' )  THEN
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',E14.7)' ) &
+                  'value', attributes(i)%value_real32
+            ELSEIF (  TRIM(attributes(i)%data_type) == 'real64' )  THEN
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',E22.15)' ) &
+                  'value', attributes(i)%value_real64
+            ENDIF
+            IF ( i < nelement )  &
+               WRITE( debug_output_unit, TRIM( write_format1 ) // ')' ) separation_string
+         ENDDO
+
+      END SUBROUTINE print_attributes
+
+      !--------------------------------------------------------------------------------------------!
+      ! Description:
+      ! ------------
+      !> Print list of dimensions.
+      !--------------------------------------------------------------------------------------------!
+      SUBROUTINE print_dimensions( indent_level, dimensions )
+
+         CHARACTER(LEN=50) ::  write_format1  !< format for write statements
+         CHARACTER(LEN=50) ::  write_format2  !< format for write statements
+
+         INTEGER             ::  i                        !< loop index
+         INTEGER, INTENT(IN) ::  indent_level             !< indentation level
+         INTEGER             ::  j                        !< loop index
+         INTEGER, PARAMETER  ::  max_keyname_length = 15  !< length of longest key name
+         INTEGER             ::  nelement                 !< number of elements to print
+
+         LOGICAL ::  is_masked  !< true if dimension is masked
+
+         TYPE(dimension_type), DIMENSION(:), INTENT(IN) ::  dimensions  !< list of dimensions
+
+
+         WRITE( write_format1, '(A,I3,A)' ) '(T', indent_level * indent_depth + 1, ',A'
+         WRITE( write_format2, '(A,I3,A,I3,A)' ) &
+            '(T', ( indent_level + 1 ) * indent_depth + 1, ',A,T', &
+            ( indent_level + 1 ) * indent_depth + 1 + max_keyname_length, ',(": ")'
+
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',A)' ) &
+            REPEAT( separation_string // ' ', 4 )
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ')' ) 'dimensions:'
+
+         nelement = SIZE( dimensions )
+         DO  i = 1, nelement
+            is_masked = dimensions(i)%is_masked
+
+            !-- Print general information
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',A)' ) &
+               'name', TRIM( dimensions(i)%name )
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',A)' ) &
+               'type', TRIM( dimensions(i)%data_type )
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',I7)' ) &
+               'id', dimensions(i)%id
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',I7)' ) &
+               'length', dimensions(i)%length
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',I7,A,I7)' ) &
+               'bounds', dimensions(i)%bounds(1), ',', dimensions(i)%bounds(2)
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',L1)' ) &
+               'is masked', dimensions(i)%is_masked
+
+            !-- Print information about mask
+            IF ( is_masked )  THEN
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',I7)' ) &
+                  'masked length', dimensions(i)%length_mask
+
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',L1)', ADVANCE='no' ) &
+                  'mask', dimensions(i)%mask(dimensions(i)%bounds(1))
+               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
+                  WRITE( debug_output_unit, '(A,L1)', ADVANCE='no' ) ',', dimensions(i)%mask(j)
+               ENDDO
+               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',I6)', ADVANCE='no' ) &
+                  'masked indices', dimensions(i)%masked_indices(0)
+               DO  j = 1, dimensions(i)%length_mask-1
+                  WRITE( debug_output_unit, '(A,I6)', ADVANCE='no' ) &
+                     ',', dimensions(i)%masked_indices(j)
+               ENDDO
+               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+            ENDIF
+
+            !-- Print saved values
+            IF ( ALLOCATED( dimensions(i)%values_int8 ) )  THEN
+
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',I4)', ADVANCE='no' ) &
+                  'values', dimensions(i)%values_int8(dimensions(i)%bounds(1))
+               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
+                  WRITE( debug_output_unit, '(A,I4)', ADVANCE='no' ) &
+                     ',', dimensions(i)%values_int8(j)
+               ENDDO
+               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               IF ( is_masked )  THEN
+                  WRITE( debug_output_unit, TRIM( write_format2 ) // ',I4)', ADVANCE='no' ) &
+                     'masked values', dimensions(i)%masked_values_int8(0)
+                  DO  j = 1, dimensions(i)%length_mask-1
+                     WRITE( debug_output_unit, '(A,I4)', ADVANCE='no' ) &
+                        ',', dimensions(i)%masked_values_int8(j)
+                  ENDDO
+                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               ENDIF
+
+            ELSEIF ( ALLOCATED( dimensions(i)%values_int16 ) )  THEN
+
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',I6)', ADVANCE='no' ) &
+                  'values', dimensions(i)%values_int16(dimensions(i)%bounds(1))
+               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
+                  WRITE( debug_output_unit, '(A,I6)', ADVANCE='no' ) &
+                     ',', dimensions(i)%values_int16(j)
+               ENDDO
+               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               IF ( is_masked )  THEN
+                  WRITE( debug_output_unit, TRIM( write_format2 ) // ',I6)', ADVANCE='no' ) &
+                     'masked values', dimensions(i)%masked_values_int16(0)
+                  DO  j = 1, dimensions(i)%length_mask-1
+                     WRITE( debug_output_unit, '(A,I6)', ADVANCE='no' ) &
+                        ',', dimensions(i)%masked_values_int16(j)
+                  ENDDO
+                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               ENDIF
+
+            ELSEIF ( ALLOCATED( dimensions(i)%values_int32 ) )  THEN
+
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',I11)', ADVANCE='no' ) &
+                  'values', dimensions(i)%values_int32(dimensions(i)%bounds(1))
+               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
+                  WRITE( debug_output_unit, '(A,I11)', ADVANCE='no' ) &
+                     ',', dimensions(i)%values_int32(j)
+               ENDDO
+               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               IF ( is_masked )  THEN
+                  WRITE( debug_output_unit, TRIM( write_format2 ) // ',I11)', ADVANCE='no' ) &
+                     'masked values', dimensions(i)%masked_values_int32(0)
+                  DO  j = 1, dimensions(i)%length_mask-1
+                     WRITE( debug_output_unit, '(A,I11)', ADVANCE='no' ) &
+                        ',', dimensions(i)%masked_values_int32(j)
+                  ENDDO
+                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               ENDIF
+
+            ELSEIF ( ALLOCATED( dimensions(i)%values_intwp ) )  THEN
+
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',I11)', ADVANCE='no' ) &
+                  'values', dimensions(i)%values_intwp(dimensions(i)%bounds(1))
+               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
+                  WRITE( debug_output_unit, '(A,I11)', ADVANCE='no' ) &
+                     ',', dimensions(i)%values_intwp(j)
+               ENDDO
+               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               IF ( is_masked )  THEN
+                  WRITE( debug_output_unit, TRIM( write_format2 ) // ',I11)', ADVANCE='no' ) &
+                     'masked values', dimensions(i)%masked_values_intwp(0)
+                  DO  j = 1, dimensions(i)%length_mask-1
+                     WRITE( debug_output_unit, '(A,I11)', ADVANCE='no' ) &
+                        ',', dimensions(i)%masked_values_intwp(j)
+                  ENDDO
+                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               ENDIF
+
+            ELSEIF ( ALLOCATED( dimensions(i)%values_real32 ) )  THEN
+
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',E14.7)', ADVANCE='no' ) &
+                  'values', dimensions(i)%values_real32(dimensions(i)%bounds(1))
+               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
+                  WRITE( debug_output_unit, '(A,E14.7)', ADVANCE='no' ) &
+                     ',', dimensions(i)%values_real32(j)
+               ENDDO
+               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               IF ( is_masked )  THEN
+                  WRITE( debug_output_unit, TRIM( write_format2 ) // ',E14.7)', ADVANCE='no' ) &
+                     'masked values', dimensions(i)%masked_values_real32(0)
+                  DO  j = 1, dimensions(i)%length_mask-1
+                     WRITE( debug_output_unit, '(A,E14.7)', ADVANCE='no' ) &
+                        ',', dimensions(i)%masked_values_real32(j)
+                  ENDDO
+                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               ENDIF
+
+            ELSEIF ( ALLOCATED( dimensions(i)%values_real64 ) )  THEN
+
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',E22.15)', ADVANCE='no' ) &
+                  'values', dimensions(i)%values_real64(dimensions(i)%bounds(1))
+               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
+                  WRITE( debug_output_unit, '(A,E22.15)', ADVANCE='no' ) &
+                     ',', dimensions(i)%values_real64(j)
+               ENDDO
+               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               IF ( is_masked )  THEN
+                  WRITE( debug_output_unit, TRIM( write_format2 ) // ',E22.15)', ADVANCE='no' ) &
+                     'masked values', dimensions(i)%masked_values_real64(0)
+                  DO  j = 1, dimensions(i)%length_mask-1
+                     WRITE( debug_output_unit, '(A,E22.15)', ADVANCE='no' ) &
+                        ',', dimensions(i)%masked_values_real64(j)
+                  ENDDO
+                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               ENDIF
+
+            ELSEIF ( ALLOCATED( dimensions(i)%values_realwp ) )  THEN
+
+               WRITE( debug_output_unit, TRIM( write_format2 ) // ',E22.15)', ADVANCE='no' ) &
+                  'values', dimensions(i)%values_realwp(dimensions(i)%bounds(1))
+               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
+                  WRITE( debug_output_unit, '(A,E22.15)', ADVANCE='no' ) &
+                     ',', dimensions(i)%values_realwp(j)
+               ENDDO
+               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               IF ( is_masked )  THEN
+                  WRITE( debug_output_unit, TRIM( write_format2 ) // ',E22.15)', ADVANCE='no' ) &
+                     'masked values', dimensions(i)%masked_values_realwp(0)
+                  DO  j = 1, dimensions(i)%length_mask-1
+                     WRITE( debug_output_unit, '(A,E22.15)', ADVANCE='no' ) &
+                        ',', dimensions(i)%masked_values_realwp(j)
+                  ENDDO
+                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+               ENDIF
+
+            ENDIF
+
+            IF ( ALLOCATED( dimensions(i)%attributes ) )  &
+               CALL print_attributes( indent_level+1, dimensions(i)%attributes )
+
+            IF ( i < nelement )  &
+               WRITE( debug_output_unit, TRIM( write_format1 ) // ')' ) separation_string
+         ENDDO
+
+      END SUBROUTINE print_dimensions
+
+      !--------------------------------------------------------------------------------------------!
+      ! Description:
+      ! ------------
+      !> Print list of variables.
+      !--------------------------------------------------------------------------------------------!
+      SUBROUTINE print_variables( indent_level, variables )
+
+         CHARACTER(LEN=50) ::  write_format1  !< format for write statements
+         CHARACTER(LEN=50) ::  write_format2  !< format for write statements
+
+         INTEGER             ::  i                        !< loop index
+         INTEGER, INTENT(IN) ::  indent_level             !< indentation level
+         INTEGER             ::  j                        !< loop index
+         INTEGER, PARAMETER  ::  max_keyname_length = 16  !< length of longest key name
+         INTEGER             ::  nelement                 !< number of elements to print
+
+         TYPE(variable_type), DIMENSION(:), INTENT(IN) ::  variables  !< list of variables
+
+
+         WRITE( write_format1, '(A,I3,A)' ) '(T', indent_level * indent_depth + 1, ',A'
+         WRITE( write_format2, '(A,I3,A,I3,A)' ) &
+            '(T', ( indent_level + 1 ) * indent_depth + 1, ',A,T', &
+            ( indent_level + 1 ) * indent_depth + 1 + max_keyname_length, ',(": ")'
+
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ',A)' ) &
+            REPEAT( separation_string // ' ', 4 )
+         WRITE( debug_output_unit, TRIM( write_format1 ) // ')' ) 'variables:'
+
+         nelement = SIZE( variables )
+         DO  i = 1, nelement
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',A)' ) &
+               'name', TRIM( variables(i)%name )
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',A)' ) &
+               'type', TRIM( variables(i)%data_type )
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',I7)' ) &
+               'id', variables(i)%id
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',L1)' ) &
+               'is global', variables(i)%is_global
+
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',A)', ADVANCE='no' ) &
+               'dimension names', TRIM( variables(i)%dimension_names(1) )
+            DO  j = 2, SIZE( variables(i)%dimension_names )
+               WRITE( debug_output_unit, '(A,A)', ADVANCE='no' ) &
+                  ',', TRIM( variables(i)%dimension_names(j) )
+            ENDDO
+            WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+
+            WRITE( debug_output_unit, TRIM( write_format2 ) // ',I7)', ADVANCE='no' ) &
+               'dimension ids', variables(i)%dimension_ids(1)
+            DO  j = 2, SIZE( variables(i)%dimension_names )
+               WRITE( debug_output_unit, '(A,I7)', ADVANCE='no' ) &
+                  ',', variables(i)%dimension_ids(j)
+            ENDDO
+            WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
+
+            IF ( ALLOCATED( variables(i)%attributes ) )  &
+               CALL print_attributes( indent_level+1, variables(i)%attributes )
+            IF ( i < nelement )  &
+               WRITE( debug_output_unit, TRIM( write_format1 ) // ')' ) separation_string
+         ENDDO
+
+      END SUBROUTINE print_variables
+
+END SUBROUTINE dom_database_debug_output
 
 END MODULE data_output_module
